implement i quiet run-tests mode which prints only one line per testcase
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
158fda31
DK
82dpkg() {
83 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
84}
b6b5a542
DK
85aptitude() {
86 if [ -f ./aptconfig.conf ]; then
87 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 elif [ -f ../aptconfig.conf ]; then
89 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
90 else
91 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
92 fi
93}
8d876415
DK
94
95setupenvironment() {
75954ae2 96 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 97 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 98 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 99 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
100 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
101 local OLDWORKINGDIRECTORY=$(pwd)
f213b6ea
DK
102 CURRENTTRAP="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
103 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
8d876415 104 cd $TMPWORKINGDIRECTORY
cd725954 105 mkdir rootdir aptarchive keys
8d876415 106 cd rootdir
b29c3712
DK
107 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
108 mkdir -p var/cache var/lib var/log
cffea9af 109 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 110 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
111 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
112 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
113 else
114 touch var/lib/dpkg/status
115 fi
cd725954 116 touch var/lib/dpkg/available
8d876415
DK
117 mkdir -p usr/lib/apt
118 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
119 cd ..
2c6baa5a 120 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
121 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
122 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 123 fi
4a4ea26c
AM
124 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
125 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
126 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
4a4ea26c 127 fi
cd725954
DK
128 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
129 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 130 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 131 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
132 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
133 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 134 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
135 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
136 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
137 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
138 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
139 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
140 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 141 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
142 export LC_ALL=C
143 msgdone "info"
144}
145
146configarchitecture() {
147 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
148 echo "APT::Architecture \"$1\";" > $CONFFILE
149 shift
150 while [ -n "$1" ]; do
151 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
152 shift
153 done
154}
155
75954ae2 156setupsimplenativepackage() {
ce9864a8
DK
157 local NAME="$1"
158 local ARCH="$2"
159 local VERSION="$3"
160 local RELEASE="${4:-unstable}"
161 local DEPENDENCIES="$5"
162 local DESCRIPTION="$6"
b7899b00
DK
163 local SECTION="${7:-others}"
164 local DISTSECTION
165 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
166 DISTSECTION="main"
167 else
168 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
169 fi
ce9864a8
DK
170 local BUILDDIR=incoming/${NAME}-${VERSION}
171 mkdir -p ${BUILDDIR}/debian/source
172 cd ${BUILDDIR}
173 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
174 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
175 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
176
177 * Initial release
178
b7899b00
DK
179 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
180 test -e debian/control || echo "Source: $NAME
181Section: $SECTION
ce9864a8
DK
182Priority: optional
183Maintainer: Joe Sixpack <joe@example.org>
184Build-Depends: debhelper (>= 7)
185Standards-Version: 3.9.1
186
187Package: $NAME
b7899b00 188Architecture: $ARCH" > debian/control
ce9864a8
DK
189 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
190 if [ -z "$DESCRIPTION" ]; then
191 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
192 If you find such a package installed on your system,
193 YOU did something horribly wrong! They are autogenerated
194 und used only by testcases for APT and surf no other propose…" >> debian/control
195 else
196 echo "Description: $DESCRIPTION" >> debian/control
197 fi
b7899b00
DK
198 test -e debian/compat || echo "7" > debian/compat
199 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 200 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
201 cd - > /dev/null
202}
203
204buildsimplenativepackage() {
205 local NAME="$1"
206 local ARCH="$2"
207 local VERSION="$3"
208 local RELEASE="${4:-unstable}"
209 local DEPENDENCIES="$5"
210 local DESCRIPTION="$6"
211 local SECTION="${7:-others}"
212 local DISTSECTION
213 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
214 DISTSECTION="main"
215 else
216 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
217 fi
218 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
219 buildpackage "incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
220 rm -rf "incoming/${NAME}-${VERSION}"
221}
222
223buildpackage() {
224 local BUILDDIR=$1
225 local RELEASE=$2
226 local SECTION=$3
227 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
228 cd $BUILDDIR
229 if [ "$ARCH" = "all" ]; then
230 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
231 fi
b7899b00
DK
232 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
233 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 234 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 235 cd - > /dev/null
b7899b00 236 for PKG in $PKGS; do
75954ae2 237 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
238 done
239 for SRC in $SRCS; do
75954ae2 240 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 241 done
cffea9af 242 msgdone "info"
ce9864a8
DK
243}
244
245buildaptarchive() {
ce9864a8
DK
246 if [ -d incoming ]; then
247 buildaptarchivefromincoming $*
248 else
249 buildaptarchivefromfiles $*
250 fi
251}
252
253createaptftparchiveconfig() {
254 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
255 if [ -z "$ARCHS" ]; then
256 # the pool is empty, so we will operate on faked packages - let us use the configured archs
257 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
258 fi
ce9864a8
DK
259 echo -n 'Dir {
260 ArchiveDir "' >> ftparchive.conf
261 echo -n $(readlink -f .) >> ftparchive.conf
262 echo -n '";
263 CacheDir "' >> ftparchive.conf
264 echo -n $(readlink -f ..) >> ftparchive.conf
265 echo -n '";
b7899b00
DK
266 FileListDir "' >> ftparchive.conf
267 echo -n $(readlink -f pool/) >> ftparchive.conf
268 echo -n '";
269};
270Default {
271 Packages::Compress ". gzip bzip2 lzma";
272 Sources::Compress ". gzip bzip2 lzma";
273 Contents::Compress ". gzip bzip2 lzma";
ce9864a8
DK
274};
275TreeDefault {
276 Directory "pool/";
277 SrcDirectory "pool/";
278};
279APT {
280 FTPArchive {
281 Release {
282 Origin "joesixpack";
283 Label "apttestcases";
284 Suite "unstable";
285 Description "repository with dummy packages";
286 Architectures "' >> ftparchive.conf
287 echo -n "$ARCHS" >> ftparchive.conf
288 echo 'source";
289 };
290 };
291};' >> ftparchive.conf
b7899b00
DK
292 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
293 echo -n 'tree "dists/' >> ftparchive.conf
294 echo -n "$DIST" >> ftparchive.conf
295 echo -n '" {
ce9864a8
DK
296 Architectures "' >> ftparchive.conf
297 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
298 echo -n 'source";
299 FileList "' >> ftparchive.conf
300 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
301 echo -n '";
302 SourceFileList "' >> ftparchive.conf
303 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
304 echo -n '";
305 Sections "' >> ftparchive.conf
306 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
307 echo '";
ce9864a8 308};' >> ftparchive.conf
b7899b00 309 done
ce9864a8
DK
310}
311
312buildaptftparchivedirectorystructure() {
b7899b00
DK
313 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
314 for DIST in $DISTS; do
315 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
316 for SECTION in $SECTIONS; do
317 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
318 for ARCH in $ARCHS; do
319 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
320 done
321 mkdir -p dists/${DIST}/${SECTION}/source
322 mkdir -p dists/${DIST}/${SECTION}/i18n
323 done
ce9864a8 324 done
ce9864a8
DK
325}
326
9b78cda6
DK
327insertpackage() {
328 local RELEASE="$1"
329 local NAME="$2"
330 local ARCH="$3"
331 local VERSION="$4"
332 local DEPENDENCIES="$5"
333 local ARCHS="$ARCH"
334 if [ "$ARCHS" = "all" ]; then
335 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
336 fi
337 for BUILDARCH in $ARCHS; do
338 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
339 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
340 touch aptarchive/dists/${RELEASE}/main/source/Sources
341 local FILE="${PPATH}/Packages"
342 echo "Package: $NAME
343Priority: optional
344Section: other
2c085486 345Installed-Size: 42
9b78cda6
DK
346Maintainer: Joe Sixpack <joe@example.org>
347Architecture: $ARCH
2c085486
DK
348Version: $VERSION
349Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
9b78cda6
DK
350 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
351 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
352 If you find such a package installed on your system,
353 YOU did something horribly wrong! They are autogenerated
354 und used only by testcases for APT and surf no other propose…
355" >> $FILE
356 done
357}
358
ce9864a8 359buildaptarchivefromincoming() {
3cbbda3c 360 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
361 cd aptarchive
362 [ -e pool ] || ln -s ../incoming pool
363 [ -e ftparchive.conf ] || createaptftparchiveconfig
364 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 365 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 366 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
367 cd - > /dev/null
368 msgdone "info"
9b78cda6 369 generatereleasefiles
ce9864a8
DK
370}
371
372buildaptarchivefromfiles() {
3cbbda3c 373 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
374 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
375 msgninfo "\t${line} file… "
376 cat ${line} | gzip > ${line}.gz
377 cat ${line} | bzip2 > ${line}.bz2
378 cat ${line} | lzma > ${line}.lzma
8d876415 379 msgdone "info"
9b78cda6
DK
380 done
381 generatereleasefiles
382}
383
384generatereleasefiles() {
385 msgninfo "\tGenerate Release files… "
386 if [ -e aptarchive/dists ]; then
387 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 388 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
389 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
390 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
391 sed -i '/^Date: / a\
392NotAutomatic: yes' $dir/Release
393 fi
9b78cda6
DK
394 done
395 else
396 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 397 fi
b7899b00 398 msgdone "info"
8d876415
DK
399}
400
b7899b00
DK
401setupdistsaptarchive() {
402 local APTARCHIVE=$(readlink -f ./aptarchive)
403 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
404 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
405 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
406 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
407 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
408 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
409 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
410 msgdone "info"
411 done
412}
413
414setupflataptarchive() {
ce9864a8 415 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
416 if [ -f ${APTARCHIVE}/Packages ]; then
417 msgninfo "\tadd deb sources.list line… "
418 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
419 msgdone "info"
420 else
421 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
422 fi
423 if [ -f ${APTARCHIVE}/Sources ]; then
424 msgninfo "\tadd deb-src sources.list line… "
425 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
426 msgdone "info"
427 else
428 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
429 fi
b7899b00
DK
430}
431
432setupaptarchive() {
433 buildaptarchive
434 if [ -e aptarchive/dists ]; then
435 setupdistsaptarchive
436 else
437 setupflataptarchive
438 fi
f213b6ea 439 signreleasefiles
cd725954 440 msgninfo "\tSync APT's cache with the archive… "
8d876415 441 aptget update -qq
cd725954 442 msgdone "info"
8d876415
DK
443}
444
f213b6ea
DK
445signreleasefiles() {
446 local SIGNER="${1:-Joe Sixpack}"
447 msgninfo "\tSign archive with $SIGNER key… "
448 local SECKEYS=""
449 for KEY in $(find keys/ -name '*.sec'); do
450 SECKEYS="$SECKEYS --secret-keyring $KEY"
451 done
452 local PUBKEYS=""
453 for KEY in $(find keys/ -name '*.pub'); do
454 PUBKEYS="$PUBKEYS --keyring $KEY"
455 done
456 for RELEASE in $(find aptarchive/ -name Release); do
457 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
458 done
459 msgdone "info"
460}
461
462changetowebserver() {
463 if which weborf > /dev/null; then
464 weborf -xb aptarchive/ 2>&1 > /dev/null &
0dc05bf0 465 CURRENTTRAP="kill $!; $CURRENTTRAP"
f213b6ea
DK
466 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
467 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
468 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
469 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
470 done
471 return 0
472 fi
473 return 1
474}
475
476checkdiff() {
8d876415
DK
477 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
478 if [ -n "$DIFFTEXT" ]; then
479 echo
480 echo "$DIFFTEXT"
481 return 1
482 else
483 return 0
484 fi
485}
486
75954ae2
DK
487testfileequal() {
488 local FILE="$1"
489 shift
490 msgtest "Test for correctness of file" "$FILE"
491 if [ -z "$*" ]; then
f213b6ea 492 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 493 else
f213b6ea 494 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
495 fi
496}
497
8d876415
DK
498testequal() {
499 local COMPAREFILE=$(mktemp)
500 echo "$1" > $COMPAREFILE
501 shift
502 msgtest "Test for equality of" "$*"
f213b6ea 503 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8e86786b 504 rm $COMPAREFILE
8d876415
DK
505}
506
685625bd
DK
507testequalor2() {
508 local COMPAREFILE1=$(mktemp)
509 local COMPAREFILE2=$(mktemp)
510 local COMPAREAGAINST=$(mktemp)
511 echo "$1" > $COMPAREFILE1
512 echo "$2" > $COMPAREFILE2
513 shift 2
514 msgtest "Test for equality OR of" "$*"
515 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
516 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
517 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
518 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
519 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd 520 msgfail )
8e86786b 521 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
685625bd
DK
522}
523
8d876415 524testshowvirtual() {
4bec02c2 525 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
526 local PACKAGE="$1"
527 shift
528 while [ -n "$1" ]; do
529 VIRTUAL="${VIRTUAL}
4bec02c2 530N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
531 PACKAGE="${PACKAGE} $1"
532 shift
533 done
534 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
535 VIRTUAL="${VIRTUAL}
4bec02c2 536N: No packages found"
8d876415
DK
537 local COMPAREFILE=$(mktemp)
538 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
539 eval `apt-config shell ARCH APT::Architecture`
540 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 541 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8e86786b 542 rm $COMPAREFILE
8d876415
DK
543}
544
545testnopackage() {
546 msgtest "Test for non-existent packages" "apt-cache show $*"
547 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
548 if [ -n "$SHOWPKG" ]; then
549 echo
550 echo "$SHOWPKG"
551 msgfail
552 return 1
553 fi
554 msgpass
555}
01a6e24c
DK
556
557testdpkginstalled() {
558 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
559 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
560 if [ "$PKGS" != 0 ]; then
561 echo $PKGS
562 dpkg -l $* | grep '^[a-z]'
563 msgfail
564 return 1
565 fi
566 msgpass
567}
568
569testdpkgnoninstalled() {
570 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
571 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
572 if [ "$PKGS" != 0 ]; then
573 echo
574 dpkg -l $* | grep '^[a-z]'
575 msgfail
576 return 1
577 fi
578 msgpass
579}